/**********************************************************************
** Copyright (C) 2002 Bill Wetter  All rights reserved.
**
**
**
** This file may be distributed and/or modified under the terms of the
** GNU General Public License version 2 as published by the Free Software
** Foundation and appearing in the file LICENSE.GPL included in the
** packaging of this file.
**
** This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
** WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
**
** 
** Contact billw@tinyapp.com  with any problems or if any conditions of this 
** licensing are not clear to you.
**
**********************************************************************/

#ifndef MAIN_H
#define MAIN_H

#include "qmyview.h"
#include <qwidget.h>
#include<qmenubar.h>


class QCanvas;
class CanvasPixmapArray;
class QCanvasSprite;
class QGamePiece; 
class QMenuBar;
class QPopupMenu;
class QMyView;

class MainWidget : public QWidget
{
	Q_OBJECT

 public:
	MainWidget( QWidget* parent = 0, const char* name = 0, WFlags fl = 0);

	QCanvasPixmapArray* iqImages;
	QCanvasSprite* DragPiece;
	QMenuBar* menu;
	QCanvas* MyCanvas;
	QGamePiece* MyPieceList[45];
	QMyView* MyView; // the canvas view

 public slots:
	void quit();
	void newGame();
	void AboutBox();
	void InstructBox();
	

 private:
	void setUpBoard();
	void makeMenu();

};
#endif











