#!/bin/sh

VERSION=1.1ern

if [ "$1" = "cross" ]; then
    export CROSSCOMPILE=/opt/Embedix/tools
    export QPEDIR=/opt/Qtopia/sharp
    export QTDIR=/opt/Qtopia/sharp
    export PATH=$QTDIR/bin:$QPEDIR/bin:$CROSSCOMPILE/bin:$PATH
    export TMAKEPATH=/opt/Qtopia/tmake/lib/qws/linux-sharp-g++/
    export LD_LIBRARY_PATH=$QTDIR/lib:$LD_LIBRARY_PATH
    export ARCHITECTURE=arm
elif [ "$1" = "native" ]; then
    export CROSSCOMPILE=
    export QPEDIR=/opt/Qtopia
    export QTDIR=/opt/Qtopia
    export PATH=$QTDIR/bin:$QPEDIR/bin:$PATH:/opt/Embedix/tools/bin
    export TMAKEPATH=/opt/Qtopia/tmake/lib/qws/linux-x86-g++/
    export LD_LIBRARY_PATH=$QTDIR/lib:$LD_LIBRARY_PATH
    export ARCHITECTURE=x86
else
    echo "usage: $0 cross | native"
    exit 1
fi

tmake -o Makefile ziq.pro
make
lrelease ziq.pro

for LANGUAGE in en de; do
    mkdir -p tmp/CONTROL
    mkdir -p tmp/opt/QtPalmtop/apps/Games
    mkdir -p tmp/opt/QtPalmtop/bin
    mkdir -p tmp/opt/QtPalmtop/pics
    mkdir -p tmp/opt/QtPalmtop/pics/ziq
    if [ "$LANGUAGE" != "en" ]; then
	mkdir -p tmp/opt/QtPalmtop/help/${LANGUAGE}/html
	mkdir -p tmp/opt/QtPalmtop/i18n/${LANGUAGE}
    else
	mkdir -p tmp/opt/QtPalmtop/help/html
    fi
    cp ziq.desktop tmp/opt/QtPalmtop/apps/Games
    cp ziq tmp/opt/QtPalmtop/bin
    cp ziq.png tmp/opt/QtPalmtop/pics
    cp iqpic*.png tmp/opt/QtPalmtop/pics/ziq
    if [ "$LANGUAGE" != "en" ]; then
	cp help/${LANGUAGE}/ziq.html tmp/opt/QtPalmtop/help/${LANGUAGE}/html
	cp i18n/${LANGUAGE}/ziq.qm tmp/opt/QtPalmtop/i18n/${LANGUAGE}
    else
	cp help/en/ziq.html tmp/opt/QtPalmtop/help/html
    fi
    cat > tmp/CONTROL/control <<END
Version: ${VERSION}
Depends: qpe-base (\$QPE_VERSION)
Priority: optional
Section: Games
Maintainer: Robert Ernst <robert.ernst@linux-solutions.at>
Architecture: ${ARCHITECTURE}
License: GPL
Description: ZIQ
 The classic IQ game.
END
    if [ "$LANGUAGE" != "en" ]; then
	cat >> tmp/CONTROL/control <<END
Package: ziq-${LANGUAGE}
Files: bin/ziq apps/Games/ziq.desktop pics/ziq.png help/${LANGUAGE}/html/ziq.html
Filename: ./ziq-${LANGUAGE}_${VERSION}_${ARCHITECTURE}.ipk
END
    else
	cat >> tmp/CONTROL/control <<END
Package: ziq
Files: bin/ziq apps/Games/ziq.desktop pics/ziq.png help/html/ziq.html
Filename: ./ziq_${VERSION}_${ARCHITECTURE}.ipk
END
    fi
    ipkg-build tmp
    rm -rf tmp
done

