/**********************************************************************
** Copyright (C) 2002 Bill Wetter  All rights reserved.
**
**
**
** This file may be distributed and/or modified under the terms of the
** GNU General Public License version 2 as published by the Free Software
** Foundation and appearing in the file LICENSE.GPL included in the
** packaging of this file.
**
** This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
** WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
**
** 
** Contact billw@tinyapp.com  with any problems or if any conditions of this 
** licensing are not clear to you.
**
**********************************************************************/

#include<qmessagebox.h>
#include "qmyview.h"


int QGamePiece::pieceMatch(int v){
	int d = 0;
	for(int c=0; c < 4; c++){
		
		if(jumpList[c]== v) 
		{ 
			d  = 1;
		}
		
	}
	
	if(d==1){
		return 1;
	} else{
		return 0;
	}

}

int QMyView::checkDrop(double tempX, double tempY)
{
	QCanvasItemList list = canvas()->allItems();
	
	int d = 0;
	while (d == 0){
		QCanvasItem* item = list.first();
		QGamePiece* s = (QGamePiece*)item;
		if( s->x() == tempX  &&  s->y() == tempY ){
			if(s->frame() == 0){
				s->setFrame(1);
				return 1;
			} else {
				return 0;
			}
			d = 1;
		} else {
			list.remove(list.begin());
			if(list.isEmpty() ){ d=1; }
		}

	}
		
	return 0;
}

int QMyView::testDrop(double tempX, double tempY)
{
	QCanvasItemList list = canvas()->allItems();
	
	int d = 0;
	while (d == 0){
		QCanvasItem* item = list.first();
		QGamePiece* s = (QGamePiece*)item;
		if( s->x() == tempX  &&  s->y() == tempY ){
			if(s->frame() == 0){
				return 1;
			} else {
				return 0;
			}
			d = 1;
		} else {
			list.remove(list.begin());
			if(list.isEmpty() ){ d=1; }
		}

	}
		
	return 0;
}

void QMyView::checkStatus()
{
	QCanvasItemList list = canvas()->allItems();
	int pieceCount = 0;
	int gotMatch = 0;
	int d = 0;
	while (d == 0){
		QCanvasItem* item = list.first();
		QGamePiece* s = (QGamePiece*)item;
	
		if(s->frame()==0){

			if( findMatch(s)){
				gotMatch = 1;
				d = 1;
			}else{
				pieceCount = pieceCount + 1;
			}
		}

		list.remove(list.begin());
		if(list.isEmpty() ){ d=1; }

	}
	if (gotMatch == 0)
	{
		char aboutStr[30];
		QString textStr;
		sprintf(aboutStr,tr("%d pieces left.<br><br>"),pieceCount-1);
		textStr= aboutStr;
		
		switch (pieceCount-1)
		{
			case 1  :	textStr += tr("You are a Genius!");
								break;
			case 2  : textStr += tr("You are closing in on genius.");
								break;
			case 3  : textStr += tr("Above Average.");
								break;
			case 4  :	textStr += tr("Good Job.");
								break;
			default :	textStr += tr("You need practice.");
								break;
		}
		
		QMessageBox mb(tr("Game Over"), textStr, QMessageBox::NoIcon,
                   QMessageBox::Ok | QMessageBox::Default,
									 QMessageBox::NoButton, QMessageBox::NoButton, parentWidget());
		mb.adjustSize();
		mb.exec();
	}
}

int QMyView::findMatch(QGamePiece* f){

	QCanvasItemList plist = canvas()->allItems();
	int checkMove = 0;
	int e = 0;
	while (e == 0){
		QCanvasItem* pitem = plist.first();
		QGamePiece* t = (QGamePiece*)pitem;

		if(f->pieceMatch(t->numInList) == 1 && t->frame()==1){

			if(t->x() == f->x()){
				if(t->y() < f->y()){
					checkMove = testDrop(t->x(), t->y()+25);
				} else{
					checkMove = testDrop(t->x(), t->y()-25);
				}
			} else {
				if(t->x() < f->x()){
					checkMove = testDrop(t->x()+25, t->y());
				} else{
					checkMove = testDrop(t->x()-25, t->y() );
				}
			
			}
		
		if(checkMove){ e = 1;}

		}
		

		plist.remove(plist.begin());
		if(plist.isEmpty() ){ e=1; }
		
	}
	if(checkMove){
		return 1;
	} else {
		return 0;	
	}

}

void QMyView::setDragPiece(QCanvasSprite* b){

	wPiece = b;

}


void QMyView:: contentsMousePressEvent(QMouseEvent* e)
{
	QCanvasItemList list = canvas()->collisions(e->pos());
     	 if ( !list.isEmpty() ) {
        	 QCanvasItem* item = list.first();
	
	if (item->rtti() == 19740610) {
        		currHeldItem= (QGamePiece*)item;
		if(currHeldItem->frame() == 0){
        			currHeldItem->setFrame(1);
		
			wPiece->move(e->x()-12, e->y()-12);
			wPiece->setZ(200);
			moving = 1;
			canvas()->update();
		} 
   	 }

	
      }


}

void QMyView:: contentsMouseMoveEvent(QMouseEvent* e)
{
	if(moving){
		wPiece->move(e->x()-12, e->y()-12);
		canvas()->update();
	}
	
}

void QMyView:: contentsMouseReleaseEvent(QMouseEvent* e)
{
	if(moving){
	
	int checkMove = 0;
	moving = 0;
	wPiece->move(325, 325);
	canvas()->update();
	QCanvasItemList list = canvas()->collisions(e->pos());
     	if( !list.isEmpty() ) {
	
		QCanvasItem* item = list.last();
		QGamePiece* s = (QGamePiece*)item;
		int temp = s->numInList;
        	 	if(currHeldItem->pieceMatch(temp) == 1 && s->frame()==1){

				if(s->x() == currHeldItem->x()){
					if(s->y() < currHeldItem->y()){
						checkMove = checkDrop(s->x(), s->y() +25);
					} else{
						checkMove = checkDrop(s->x(), s->y() -25);
					}
				} else {
				if(s->x() < currHeldItem->x()){
						checkMove = checkDrop(s->x()+25, s->y());
					} else{
						checkMove = checkDrop(s->x()-25, s->y() );
					}
			
				}
			
			// checkDrop(findJumpX, findJumpY);
			if(checkMove == 1){
				s->setFrame(0);
			} else {
				currHeldItem->setFrame(0);
			}


		}else {
		currHeldItem->setFrame(0);
		}
	}else{
	currHeldItem->setFrame(0);
	}
	canvas()->update();
	checkStatus();
	}
}
















