/**********************************************************************
** Copyright (C) 2002 Bill Wetter  All rights reserved.
**
**
**
** This file may be distributed and/or modified under the terms of the
** GNU General Public License version 2 as published by the Free Software
** Foundation and appearing in the file LICENSE.GPL included in the
** packaging of this file.
**
** This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
** WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
**
** 
** Contact billw@tinyapp.com  with any problems or if any conditions of this 
** licensing are not clear to you.
**
**********************************************************************/

#include <qcanvas.h>
#include <stdio.h>



class QGamePiece : public QCanvasSprite
{
	
 public:
	QGamePiece(QCanvas* canvas, QCanvasPixmapArray* array) 
	: QCanvasSprite(array, canvas){ }
	
	int numInList;
	int jumpList[4];
	int rtti () const { return 19740610; }
	int pieceMatch(int v);

};

class QMyView : public QCanvasView
{
	Q_OBJECT

 public:
	QMyView(QCanvas* canvas = 0, QWidget* parent=0, const char* name = 0, WFlags fl = 0)
	:QCanvasView(canvas, parent,name, fl){ }
	
	int findMatch(QGamePiece*);
	void checkStatus();
	QCanvasSprite* wPiece;
	QGamePiece* currHeldItem; // which piece are you holding at the moment
	void setDragPiece(QCanvasSprite*);
	int checkDrop(double tempX, double tempY);

private:
	int testDrop(double tempX, double tempY);
	bool moving;
protected:
	 virtual void contentsMousePressEvent(QMouseEvent* );
	 virtual void contentsMouseReleaseEvent(QMouseEvent* );
	 virtual void contentsMouseMoveEvent(QMouseEvent* );
};






















